# Holi Load Testing

Holi Load Testing is implemented using [Grafana k6](https://k6.io/docs/).

## Development

The xk6-dashboard is part of k6 as of version 4.49.0, so there is no need do build a custom version.

If you want to use other extensions, they can be installed via xk6: https://github.com/grafana/xk6

1. Fill `.envrc.local` with the content of `.envrc.local.template` and your user credentials;
2. Execute k6: `./k6 run --out dashboard=open --out json=results.json scripts/main.js`.

Unfortunately replay is not possible with the built in dashboard. It can be done by building a k6 older than 4.49.0 and with xk6-dashboard included or by using the old [k6-dashboard-cli](https://github.com/grafana/xk6-dashboard/blob/master/cmd/k6-web-dashboard/README.md)\
To view the dashboard of a previously performed test execute `./k6-web-dashboard replay results.json` and open `http://127.0.0.1:5665`.

## Installation:

### Docker

To run Holi Load Testing locally, follow these steps:

1. Clone the repository;
2. Fill `.envrc.local` with the content of `.envrc.local.template` and your user credentials;
3. Execute `docker-compose up -d`;
4. Go to `http://127.0.0.1:5665` when the logo here below appears:

```

         /\      |‾‾| /‾‾/   /‾‾/   
    /\  /  \     |  |/  /   /  /    
   /  \/    \    |     (   /   ‾‾\  
  /          \   |  |\  \ |  (‾)  | 
 / __________ \  |__| \__\ \_____/ .io
```

## Performance Testing

In addition to load testing, we added performance testing to this repository, also using k6. Performance testing is all about repeatable query performance without the parallel load part. So it's about measuring the average and percentile runtimes of single queries before and/or after changes potentially impacting query performance.

In order to run all these tests, execute:

```
./performance-test.sh
```

And if you want to run a single test (e.g. during development), you can run a command line like:

```
k6 run --env TEST=spaceById scripts/performance-measurement.js
```

replacing the TEST env variable with a test for a query you want to run. For a list of potential test names, see the file `performance-measurement.js`, looking for the `tests` data structure.